#include "lcd.h"

void grab_parport(unsigned int parport_addr) {
  if(ioperm(parport_addr,3,1)) { perror("ioperm"); exit(1);}
  PARPORT_BASE = parport_addr;
}

void lcd_send_instruction(unsigned char inst) {
  outb(0x03,CONTROL);
  outb(inst,PARPORT_BASE);
  outb(0x02,CONTROL);
  usleep(1000);
  outb(0x03,CONTROL);
  usleep(5000);
}

void lcd_send_data(unsigned char data) {
  outb(0x07,CONTROL);
  outb(data,PARPORT_BASE);
  outb(0x06,CONTROL);
  usleep(1000);
  outb(0x07,CONTROL);
  usleep(5000);
}


void lcd_display_line(unsigned char fill_dir, unsigned char line_num, char * msg) {
  int i;
  if(line_num < NUM_LINES) {
    switch(fill_dir) {
      case(FILL_RIGHT):
        lcd_send_instruction(0x06);
        lcd_send_instruction(SET_DISPLAY_ADDRESS | LINE_ADDR[line_num]);
        for(i = 0; i < CHARS_PER_LINE; i++) {
          lcd_send_data(*(msg+i));
        }
        break;
      case(FILL_LEFT):
        lcd_send_instruction(SET_DISPLAY_ADDRESS | (LINE_ADDR[line_num] + 19));
        lcd_send_instruction(0x04);
        for(i = CHARS_PER_LINE-1; i >= 0; i--) {
          lcd_send_data(*(msg+i));
        }
        break;
    }
  }
}

void lcd_initialize(void) {
  lcd_send_instruction(0x38);
  lcd_send_instruction(0x38);
  lcd_send_instruction(0x38);
  lcd_send_instruction(0x38);

  lcd_send_instruction(0x08);
  lcd_send_instruction(0x01);
  lcd_send_instruction(0x06);

  lcd_send_instruction(0x0c);
  lcd_send_instruction(0x02);
}
