#include <stdio.h>
#include <unistd.h>
#include <asm/io.h>

static unsigned int PARPORT_BASE;

static unsigned char LINE_ADDR[4] = {0x00, 0x40, 0x14, 0x54};

#define STATUS PARPORT_BASE+1
#define CONTROL PARPORT_BASE+2

/* Control Register Masks */
#define EN_BIT 0x01
#define RW_BIT 0x02
#define RS_BIT 0x04

#define NUM_LINES 4
#define CHARS_PER_LINE 20

#define FILL_RIGHT 0
#define FILL_LEFT 1

/* instructions */
#define SET_DISPLAY_ADDRESS 0x80

void grab_parport(unsigned int parport_addr);

/* LCD functions */
void lcd_send_instruction(unsigned char inst);
void lcd_send_data(unsigned char data);
void lcd_display_line(unsigned char fill_dir, unsigned char line_num, char * msg);
void lcd_initialize(void);

/* input functions */
void get_line_msg(int * line_num, char * msg, int msg_length);
